#ifndef _MYTYPES_H_
#define _MYTYPES_H_

typedef unsigned char  uint8_t;
typedef unsigned short uint16_t; 
typedef unsigned short uint32_t; 

#define LOW(x)     (*((unsigned char*)&(##x)+1))             // returns the low part
#define HIGH(x)    (*((unsigned char*)&(##x)+0))             // returns the high part
#define CALL(addr) (((void(*)(void))(uint8_t code *)addr)()) //call any 
#define CBYTE      ((unsigned char volatile code *) 0)       //from absacc.h
#define LED1   TXD      
#define LED3   RXD 
#define SW1    INT0

// use this macros to set a contition on a specific endpoint without changing any other bits 
// it can be used on EP0 too but using the specialized EP0_xx macros will be more eficient
// params ep:  EP number 1..4
//        dir: T or R; T selects IN R selects OUT
#define UNSTALL(ep,dir) (UEP ##ep ##_CTRL &= (~MASK_UEP_ ##dir ##_RES) | UEP_ ##dir ##_RES_TOUT) // 01
#define NAK(ep,dir)     (UEP ##ep ##_CTRL &= (~MASK_UEP_ ##dir ##_RES) | UEP_ ##dir ##_RES_NAK)  // 10
#define ACK(ep,dir)     (UEP ##ep ##_CTRL &= ~MASK_UEP_ ##dir ##_RES)                            // 00
#define STALL(ep,dir)   (UEP ##ep ##_CTRL |=  UEP_ ##dir ##_RES_STALL)                           // 11 

// used to do a protocoll stall
//#define EP0_STALL_ALL
//#define EP0_NAK(dir)
//#define EP0_ARM(size)

#endif
